/* graphArray - autor : Ioan Stoianov */

import java.awt.Color;
import java.awt.Graphics;
import java.util.Vector;

class graphArray
{
    int counter;
    int x;
    int y;
    int step;
    int cost;
    int costs;
    Vector v = new Vector();
    final char labels[] = {' ','A','B','C','D','E','F','G','H','I','J'};
    
    public graphArray(int x, int y, int step) {
	this.x = x;
	this.y = y;
	this.step = step;
    }
    
    public void printCost(Graphics d, int x, int y) {
	d.drawString(("Costul total : " + String.valueOf(costs)), x, y);
    }
    
    public void initialize() {
	v.removeAllElements();
	costs = 0;
    }
    
    public node findNode(int number) {
	for (int i = 0; i < v.size(); i++) {
	    node hNode = (node) v.elementAt(i);
	    if (hNode.number == number)
		return hNode;
	}
	return null;
    }
    
    public void setLeftDown(node father, node son, int cost) {
	father.leftdownx = son.x;
	father.leftdowny = son.y;
	father.leftdownc = cost;
	father.leftdownn = son.number;
    }
    
    public void setRightDown(node father, node son, int cost) {
	father.rightdownx = son.x;
	father.rightdowny = son.y;
	father.rightdownc = cost;
	father.rightdownn = son.number;
    }
    
    public void setDown(node father, node son, int cost) {
	father.downx = son.x;
	father.downy = son.y;
	father.downc = cost;
	father.downn = son.number;
    }
    
    public void setRight(node father, node son, int cost) {
	father.rightx = son.x;
	father.righty = son.y;
	father.rightc = cost;
	father.rightn = son.number;
    }
    
    public void setLeft(node father, node son, int cost) {
	father.leftx = son.x;
	father.lefty = son.y;
	father.leftc = cost;
	father.leftn = son.number;
    }
    
    public void setAllDownNodes(node father, int change) {
	for (int i = 0; i < v.size(); i++) {
	    node theNode = (node) v.elementAt(i);
	    for (node helpNode = theNode; helpNode.upn != 0;
		 helpNode = findNode(helpNode.upn)) {
		if (helpNode.upn == father.number) {
		    theNode.x += change;
		    node helpNode2 = findNode(theNode.upn);
		    if (helpNode2.rightn == theNode.number)
			helpNode2.rightx += change;
		    if (helpNode2.downn == theNode.number)
			helpNode2.downx += change;
		    if (helpNode2.leftdownn == theNode.number)
			helpNode2.leftdownx += change;
		    if (helpNode2.rightdownn == theNode.number)
			helpNode2.rightdownx += change;
		}
	    }
	}
    }
    
    public void checkForSamexy() {
	boolean found = true;
	for (int loop = v.size() - 1; loop >= 0; loop--) {
	    node n = (node) v.elementAt(loop);
	    for (int i = 0; i < v.size(); i++) {
		node theNode = (node) v.elementAt(i);
		if (theNode != n && theNode.x == n.x && theNode.y == n.y) {
		    found = true;
		    node helpNode = findNode(theNode.upn);
		    node helpNode2 = findNode(n.upn);
		    if (helpNode2.x > n.x)
			setAllDownNodes(helpNode, -step);
		    else if (helpNode2.x == n.x) {
			if (helpNode.x < theNode.x)
			    setAllDownNodes(helpNode, -step);
		    } else
			setAllDownNodes(helpNode, step);
		}
	    }
	}
    }
    
    public void addNode(int number, int father, int cost) {
	node myNode = new node();
	this.costs += cost;
	if (v.size() == 0) {
	    myNode.setxy(number, x, y);
	    myNode.upn = 0;
	    v.addElement(myNode);
	} else {
	    for (int i = 0; i < v.size(); i++) {
		node hNode = (node) v.elementAt(i);
		if (hNode.number == father) {
		    if (hNode.downx == 0) {
			if (hNode.leftdownx == 0)
			    myNode.setxy(number, hNode.x, (hNode.y + step));
			else
			    myNode.setxy(number, (hNode.leftdownx + step),
					 (hNode.y + step));
			myNode.upn = father;
			v.addElement(myNode);
			setDown(hNode, myNode, cost);
		    } else if (hNode.downx != 0 && hNode.leftdownx != 0
			       && hNode.rightdownx != 0 && hNode.rightx != 0) {
			myNode.setxy(number, (hNode.x - step * 2),
				     (hNode.y + step));
			myNode.upn = father;
			v.addElement(myNode);
			setLeft(hNode, myNode, cost);
		    } else if (hNode.downx != 0 && hNode.leftdownx != 0
			       && hNode.rightdownx != 0) {
			myNode.setxy(number, (hNode.x + step * 2),
				     (hNode.y + step));
			myNode.upn = father;
			v.addElement(myNode);
			setRight(hNode, myNode, cost);
		    } else {
			node downNode = findNode(hNode.downn);
			hNode.downx = 0;
			hNode.downy = 0;
			hNode.downn = 0;
			myNode.setxy(number, (hNode.x + step), (hNode.y + step));
			myNode.upn = father;
			downNode.x = hNode.x - step;
			v.addElement(myNode);
			setLeftDown(hNode, downNode, hNode.downc);
			setAllDownNodes(downNode, -step);
			hNode.downc = 0;
			setRightDown(hNode, myNode, cost);
		    }
		    checkForSamexy();
		}
	    }
	}
    }
    
    public void drawGraph(Graphics g) {
	for (int loop1 = 0; loop1 < v.size(); loop1++) {
	    node hNode = (node) v.elementAt(loop1);
	    if (hNode.leftx != 0) {
		g.drawLine(hNode.x + 10, hNode.y + 10,
			   hNode.leftx + 2, hNode.lefty + 10);
		g.drawString(String.valueOf(hNode.leftc),
			     (hNode.x + (hNode.leftx - hNode.x) / 2 + 8),
			     (hNode.y + (hNode.lefty - hNode.y) / 2 + 11));
	    }
	    if (hNode.rightx != 0) {
		g.drawLine(hNode.x + 10, hNode.y + 10,
			   hNode.rightx + 2, hNode.righty + 10);
		g.drawString(String.valueOf(hNode.rightc),
			     (hNode.x + (hNode.rightx - hNode.x) / 2 + 8),
			     (hNode.y + (hNode.righty - hNode.y) / 2 + 11));
	    }
	    if (hNode.downx != 0) {
		g.drawLine(hNode.x + 10, hNode.y + 10,
			   hNode.downx + 10, hNode.downy + 10);
		g.drawString(String.valueOf(hNode.downc),
			     (hNode.x + (hNode.downx - hNode.x) / 2 + 13),
			     (hNode.y + (hNode.downy - hNode.y) / 2 + 15));
	    }
	    if (hNode.rightdownx != 0) {
		g.drawLine(hNode.x + 10, hNode.y + 10,
			   hNode.rightdownx + 10, hNode.rightdowny + 10);
		g.drawString(String.valueOf(hNode.rightdownc),
			     hNode.x + (hNode.rightdownx - hNode.x) / 2 + 12,
			     hNode.y + (hNode.rightdowny - hNode.y) / 2 + 12);
	    }
	    if (hNode.leftdownx != 0) {
		g.drawLine(hNode.x + 10, hNode.y + 10,
			   hNode.leftdownx + 10, hNode.leftdowny + 10);
		g.drawString(String.valueOf(hNode.leftdownc),
			     hNode.x + (hNode.leftdownx - hNode.x) / 2 + 3,
			     hNode.y + (hNode.leftdowny - hNode.y) / 2 + 12);
	    }
	}
	for (int loop1 = 0; loop1 < v.size(); loop1++) {
	    node hNode = (node) v.elementAt(loop1);
	    g.setColor(Color.lightGray);
	    g.fillOval(hNode.x, hNode.y, 18, 18);
	    g.setColor(Color.black);
	    g.drawOval(hNode.x, hNode.y, 18, 18);
	    g.drawChars(labels, hNode.number, 1, hNode.x + 6, hNode.y + 12);
	}
    }
}
