/* primArray - autor : Ioan Stoianov */

import java.applet.Applet;
import java.awt.Button;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class primArray extends Applet implements ActionListener
{
    graph gr = new graph(13, 55, 45, 45);
    graphArray gra = new graphArray(515, 55, 33);
    primSolution p = new primSolution();
    final int n = 10;
    final char labels[] = {' ','A','B','C','D','E','F','G','H','I','J'};
    int ary = 85;
    int arx = 200;
    int box = 15;
    Graphics d;
    Graphics gtrue;
    Image im;
    Font f = new Font("Arial ", 1, 10);
    int[][] A = new int[10][10];
    boolean[][] Ahelp = new boolean[10][10];
    boolean[] Cols = new boolean[10];
    int xi;
    int yi;
    int[] HoldMarks = new int[10];
    boolean allDesign;
    int point;
    int step = -1;
    Button button1;
    Button button2;
    Button button3;
    
    public void resetData() {
	for (int i = 0; i < 10; i++) {
	    Cols[i] = false;
	    for (int j = 0; j < 10; j++)
		Ahelp[i][j] = false;
	}
	for (int help = 0; help < 10; help++)
	    HoldMarks[help] = 0;
    }
    
    public void putRandomData() {
	resetData();
	point = 0;
	step = -1;
	gr.setMaximumNodes(10, 4, 3, true);
	do {
	    gr.putRandomNodes();
	    p.initialize(gr);
	} while (!p.synecticos());
	p.initialize(gr);
	gra.initialize();
	A = gr.getArray(10);
	setActive();
	repaint();
    }
    
    void setActive() {
	for (int i = 0; i < 10; i++) {
	    for (int j = 0; j < 10; j++) {
		if (A[i][j] != 0)
		    Ahelp[i][j] = true;
	    }
	}
    }
    
    public void init() {
	im = createImage(getSize().width, getSize().height);
	d = im.getGraphics();
	gtrue = getGraphics();
	d.setFont(f);
	setLayout(null);
	button1 = new Button("Adauga un nod");
	button1.addActionListener(this);
	add(button1);
	button1.setBounds(5, 370, 120, 20);
	button2 = new Button("Solutie rapida");
	button2.addActionListener(this);
	add(button2);
	button2.setBounds(130, 370, 120, 20);
	button3 = new Button("Alt set de date");
	button3.addActionListener(this);
	add(button3);
	button3.setBounds(255, 370, 120, 20);
	putRandomData();
    }
    
    void DrawElement(int num, int i, int j) {
	String s = String.valueOf(num);
	d.setColor(Color.black);
	d.drawString(s, arx + box * j + 2,
	     ary + box * (i + 1) - 4);
    }
    
    void MarkSquare(boolean tag, int i, int j) {
	if (tag)
	    d.setColor(Color.pink);
	else
	    d.setColor(Color.gray);
	int hold1 = arx + box * j + 1;
	int hold2 = ary + box * i + 1;
	d.fillRect(hold1, hold2, box - 1, box - 1);
	if (A[i][j] != 0)
	    DrawElement(A[i][j], i, j);
	Ahelp[i][j] = false;
    }
    
    void MarkLine(int j) {
	for (int k = 0; k < 10; k++)
	    MarkSquare(false, k, j);
	Cols[j] = true;
    }
    
    void Tick(int i) {
	d.setColor(Color.black);
	d.drawLine((box * 10 + arx + box / 3),
		(ary + box / 2 + box * i),
		(box * 10 + arx + box / 2),
		(ary + box - 5 + box * i));
	d.drawLine((box * 10 + arx + box / 2),
		(ary + box - 5 + box * i),
		(box * 10 + arx + box),
		(ary - 1 + box * i));
	HoldMarks[point] = i;
	point++;
    }
    
    void PrintArray(int[][] Pinakas) {
	for (int indexi = 0; indexi < 10; indexi++) {
	    for (int indexj = 0; indexj < 10; indexj++) {
		if (Pinakas[indexi][indexj] != 0)
		    DrawElement(Pinakas[indexi][indexj], indexi, indexj);
	    }
	}
    }
    
    int FindMin() {
	int min = 1000;
	int j = 0;
	int i = 0;
	int hi = 0;
	int hj = 0;
	for (i = 0; i < 10; i++) {
	    if (isinHoldMarks(i)) {
		for (j = 0; j < 10; j++) {
		    if (Ahelp[i][j] == true
			&& A[i][j] < min
			&& A[i][j] != 0) {
			min = A[i][j];
			hi = i;
			hj = j;
		    }
		}
	    }
	}
	xi = hi;
	yi = hj;
	return min;
    }
    
    boolean AreElements() {
	for (int i = 0; i < 10; i++) {
	    if (isinHoldMarks(i)) {
		for (int j = 0; j < 10; j++) {
		    if (A[i][j] != 0
			&& Ahelp[i][j])
			return true;
		}
	    }
	}
	return false;
    }
    
    boolean isinHoldMarks(int elem) {
	for (int help = 0; help < 10; help++) {
	    if (elem == HoldMarks[help])
		return true;
	}
	return false;
    }
    
    public void redraw() {
	Color lightBlue = new Color(150, 190, 255);
	d.setColor(lightBlue);
	d.fillRect(arx, ary, box * 10, box * 10);
	d.setColor(Color.black);
	d.drawRect(arx, ary, box * 10, box * 10);
	for (int kx = arx + box; kx <= arx + box * 10; kx += box)
	    d.drawLine(kx, ary, kx, (ary + box * 10));
	for (int kx = ary + box; kx <= ary + box * 10; kx += box)
	    d.drawLine(arx, kx, (arx + box * 10), kx);
	d.setColor(Color.black);
	for (int i = 1; i <= 10; i++) {
	    d.drawChars(labels, i, 1, arx - 12, (ary + box * i - 2));
	    d.drawChars(labels, i, 1, (arx + box * (i - 1) + 2), ary - 6);
	}
	PrintArray(A);
    }
    
    public void nextStep(int delay) {
	if (step == 0) {
	    xi = 0;
	    yi = 0;
	    Tick(yi);
	    MarkLine(yi);
	    gra.addNode(1, 0, A[0][0]);
	    drawData();
	}
	if (step > 0) {
	    boolean are = AreElements();
	    if (are) {
		int themin = FindMin();
		MarkSquare(true, xi, yi);
		gtrue.drawImage(im, 0, 0, this);
		try {
		    Thread.sleep((long) delay);
		} catch (InterruptedException interruptedexception) {
		    /* empty */
		}
		MarkSquare(false, xi, yi);
		gtrue.drawImage(im, 0, 0, this);
		try {
		    Thread.sleep((long) delay);
		} catch (InterruptedException interruptedexception) {
		    /* empty */
		}
		MarkSquare(true, xi, yi);
		gtrue.drawImage(im, 0, 0, this);
		try {
		    Thread.sleep((long) delay);
		} catch (InterruptedException interruptedexception) {
		    /* empty */
		}
		Tick(yi);
		MarkLine(yi);
		gra.addNode(yi + 1, xi + 1, (A[xi][yi]));
		drawData();
	    } else {
		for (int i = 0; i < 10; i++)
		    Cols[i] = false;
		step = -1;
		redraw();
		point = 0;
		setActive();
		for (int help = 0; help < 10; help++)
		    HoldMarks[help] = 0;
		gra.initialize();
		drawData();
	    }
	}
    }
    
    public void drawData() {
	Font med = new Font("Arial", 3, 12);
	Rectangle r = getBounds();
	d.setColor(Color.white);
	d.fillRect(r.x, r.y, r.width, r.height);
	d.setColor(Color.black);
	d.drawRect(r.x, r.y, r.width - 1, r.height - 1);
	d.setFont(med);
	d.setColor(Color.blue);
	d.fillRect(r.x + 1, r.y + 1, r.width - 3, 20);
	d.setColor(Color.white);
	d.drawRect(r.x + 1, r.y + 1, r.width - 3, 20);
	d.drawString
	    ("Determinarea arborelui par\u0163ial de cost minim - Algoritmul Prim",
	     r.x + 10, r.y + 15);
	d.setColor(new Color(176, 216, 255));
	d.fillRect(3, 45, 173, 320);
	d.fillRect(181, 45, 194, 320);
	d.fillRect(380, 45, 280, 320);
	d.setColor(Color.black);
	d.drawRect(3, 45, 173, 320);
	d.drawRect(181, 45, 194, 320);
	d.drawRect(380, 45, 280, 320);
	d.setFont(f);
	d.drawString("Program demonstrativ", 535, 380);
	d.drawString("autor : Ioan Stoianov", 540, 390);
	d.drawString("Graful ini\u0163ial", 10, 40);
	d.drawString("Matricea costurilor", 190, 40);
	d.drawString("Arborele par\u0163ial generat", 390, 40);
	redraw();
	point = 0;
	for (int i = 0; i < 10; i++) {
	    if (Cols[i]) {
		MarkLine(i);
		Tick(i);
	    }
	}
	d.setColor(Color.black);
	gr.drawGraph(d);
	gra.drawGraph(d);
	gra.printCost(d, 400, 360);
	gtrue.drawImage(im, 0, 0, this);
    }
    
    public void update(Graphics e) {
	paint(e);
    }
    
    public void paint(Graphics e) {
	drawData();
    }
    
    public void clickedButton1() {
	step++;
	allDesign = false;
	nextStep(400);
    }
    
    public void clickedButton2() {
	for (int i = step + 1; i < 10; i++) {
	    step++;
	    nextStep(0);
	    drawData();
	}
    }
    
    public void clickedButton3() {
	step = 0;
	putRandomData();
    }

    public void actionPerformed(ActionEvent event) {
	if (event.getSource() == button1) {
	    clickedButton1();
	    return;
	}
	if (event.getSource() == button2) {
	    clickedButton2();
	    return;
	}
	if (event.getSource() == button3) {
	    clickedButton3();
	    return;
	}
    }

}
