program StareCivila;

const MaxPersoane = 50;

type 
  IndexPersoane = 1..MaxPersoane;
  TipStareCivila = (necasatorit, casatorit, divortat);
  Data = record
    zi: 1..31;
    luna: 1..12;
    an: 1900..3000;
  end;  {data}
  Persoana = record
    Nume: string[20];
    DataNasterii: data;
  case StareCivila: TipStareCivila of
    necasatorit: ();
    casatorit: (nrCopii: integer; numeSot: string[20]);
    divortat: (DataDivort: data);
  end;  {persoana}
  ListaPersoane = array[IndexPersoane] of Persoana;

var 
  Lista: ListaPersoane;
  NrPersoane: IndexPersoane;

function Transforma(c: char): TipStareCivila;
{stabileste starea civila a unei persoane}
begin
  case c of 
    'n', 'N': transforma := necasatorit;
    'c', 'C': transforma := casatorit;
    'd', 'D': transforma := divortat;
  end;  {case}
end;  {Transforma}

procedure CitesteData(var d: data);
{citeste o data calendaristica exprimata in zi,luna,an}
begin
  with d do
  begin
    write('   zi:   ');
    readln(zi);
    write('   luna: ');
    readln(luna);
    write('   an:   ');
    readln(an)   		
  end;{with}
end;  {CitesteDate}

procedure CitesteLista(var N: IndexPersoane; var L: ListaPersoane);
{citeste numarul de persoane din lista si informatiile asociate lor}
var
  I: IndexPersoane;
  Raspuns: char;
begin
  repeat
    write('Introduceti numarul de persoane (1-', MaxPersoane, '): ');
    readln(N);
  until (N >= 1) and (N <= MaxPersoane);
  writeln('Introduceti lista de persoane');
  for I:= 1 to N do
  begin
    writeln('    Persoana ', I:3);
    with L[I] do 
    begin
      write('Numele: ');
      readln(Nume);
      writeln('Data nasterii');
      CitesteData(DataNasterii);
      repeat
        write('Starea civila (N/C/D): ');
        readln(Raspuns);
      until Raspuns in ['N', 'n', 'C', 'c', 'D', 'd'];
      StareCivila := Transforma(Raspuns);
      case StareCivila of 
        Casatorit:
        begin
          write('Numele sotului/sotiei: ');
          readln(NumeSot);
          write('Numar copii: ');
          readln(NrCopii);
        end; {Casatorit}
        Divortat:
        begin
          writeln('Data divortului: ');
          CitesteData(DataDivort)
        end; {Divortat}
      end;{case}
    end;{with}
  end;{for}
end; {CitesteLista}

procedure Interschimba(var P1, P2: Persoana);
{interschimba continutul a doua variabile de tipul Persoana}
var Auxiliar: Persoana;
begin {Interschimba}
  Auxiliar := P1;
  P1 := P2;
  P2 := Auxiliar;
end;{interschimba}
   
Procedure Ordoneaza (N: IndexPersoane; var L: ListaPersoane);
{ordoneaza alfabetic lista de persoane}
var
  I: IndexPersoane;
  Ordonat: boolean;
begin {Ordoneaza}
  repeat 
    Ordonat := true;
    for I := 1 to N-1 do
      if L[I].Nume > l[I+1].Nume then 
      begin
        Interschimba(L[I], L[I+1]);
        Ordonat := false;
      end;
  until Ordonat;
end; {Ordoneaza}

procedure Afiseaza(N: IndexPersoane; L: ListaPersoane);
{afiseaza numele si nr-ul de copii pt pers cu mai multi copiii}
var
  I: IndexPersoane;
begin
  for I := 1 to N do
    if L[I].StareCivila = Casatorit then 
      if L[I].NrCopii > 2 then 
        writeln(L[I].Nume:20, L[I].NrCopii:3);
end; {afiseaza}

begin{progr principal}
  CitesteLista(NrPersoane, Lista);
  Ordoneaza(NrPersoane, Lista);
  Afiseaza(NrPersoane, Lista);
end.
